/** Main file for USB storage key **/

#include <avr/io.h>
#include <util/delay.h>

#define LED_DIR		DDRB
#define LED_PORT	PORTB
#define LED_BIT 	5

#define NB_ROWS 5
#define NB_COLS  7

#define DELAY_BIT 100
void oneblink(void);
volatile unsigned char *cols_d[NB_COLS]={&DDRC,&DDRD,&DDRD,&DDRD,&DDRD,&DDRD,&DDRD};
volatile unsigned char *cols_p[NB_COLS]={&PORTC,&PORTD,&PORTD,&PORTD,&PORTD,&PORTD,&PORTD};
volatile unsigned char *cols_i[NB_COLS]={&PINC,&PIND,&PIND,&PIND,&PIND,&PIND,&PIND};
int cols_n[NB_COLS]={2,0,1,2,3,4,5};

volatile unsigned char *rows_d[NB_ROWS]={&DDRD,&DDRB,&DDRB,&DDRB,&DDRB};
volatile unsigned char *rows_p[NB_ROWS]={&PORTD,&PORTB,&PORTB,&PORTB,&PORTB};
int rows_n[NB_ROWS]={6,0,1,2,3};




void oneblink(void){
LED_PORT |= (1<<5);
_delay_ms(DELAY_BIT);
LED_PORT &= ~(1<<5);
_delay_ms(DELAY_BIT);
}

void nblink(int n){
for(int i=0;i<n;i++){
  oneblink();
  }
}

void setup() {

CLKSEL0 = 0b00010101;   // sélection de l'horloge externe
CLKSEL1 = 0b00001111;   // minimum de 8Mhz
CLKPR = 0b10000000;     // modification du diviseur d'horloge (CLKPCE=1)
CLKPR = 0;              // 0 pour pas de diviseur (diviseur de 1)

//LED_DIR |= (1<<5);
//LED_PORT &= ~(1<<5);

//led
//DDRB |= (1<<5) | (1<<6);
//PORTB &= ~((1<<5) | (1<<6));


//colonnes en sortie à l'état haut
//DDRC |= (1<<2);
//PORTC &= ~(1<<2);

//ligne en entrée avec pull up
//DDRD &= ~(1<<6);
//PORTD |= (1<<6);





for(int col=0;col<NB_COLS;col++){
  *cols_d[col] &= ~(1<<cols_n[col]);
  *cols_p[col] |= (1<<cols_n[col]);
  }  
for(int row=0;row<NB_ROWS;row++){
  *rows_d[row] |= (1<<rows_n[row]);
//  *rows_p[row] |= (1<<rows_n[row]);
  *rows_p[row] &= ~(1<<rows_n[row]);
};


}

//void loop() {
//for(int row=0;row<NB_ROWS;row++){
//  digitalWrite(rows[row],LOW);
//  for(int col=0;col<NB_COLS;col++){
//    if(digitalRead(cols[col])==LOW) nblink((row+1)*(col+1));
//    }
//  digitalWrite(rows[row],HIGH);
//  }
//delay(2000);
//}

void loop() {

for(int row=0;row<NB_ROWS;row++){
  *rows_p[row] &= ~(1<<rows_n[row]);
  _delay_ms(100);

  for(int col=0;col<NB_COLS;col++){
	unsigned char key = (*cols_i[col] & (1<<cols_n[col]))?0:1;
    if (key) nblink((row+1)*(col+1));
	};
  *rows_p[row] |= (1<<rows_n[row]);
  };




}

int main(void){
setup();
while(1) loop();
}

//